searchNodes=[{"doc":"ResourceAdmin modules should be created for every schema you want to customize/configure in Kaffy. If you have a schema like MyApp.Products.Product, you should create an admin module with name MyApp.Products.ProductAdmin and add functions documented in this module to customize the behavior. All functions are optional.","ref":"Kaffy.ResourceAdmin.html","title":"Kaffy.ResourceAdmin","type":"module"},{"doc":"authorized?/2 takes the schema and the current Plug.Conn struct and should return a boolean value. Returning false will prevent the access of this resource for the current user/request. If authorized?/2 is not defined, Kaffy will return true. Example: def authorized?(_schema, _conn) do true end","ref":"Kaffy.ResourceAdmin.html#authorized?/2","title":"Kaffy.ResourceAdmin.authorized?/2","type":"function"},{"doc":"create_changeset/2 takes the record and the changes and should return a changeset for creating a new record. If create_changeset/2 is not defined, Kaffy will try to call schema.changeset/2 and if that&#39;s not defined, Ecto.Changeset.change/2 will be called. Example: def create_changeset(schema, attrs) do MyApp.Blog.Post.create_changeset(schema, attrs) end","ref":"Kaffy.ResourceAdmin.html#create_changeset/2","title":"Kaffy.ResourceAdmin.create_changeset/2","type":"function"},{"doc":"form_fields/1 takes a schema and returns a keyword list of fields and their options for the new/edit form. Supported options are: :label, :type, :choices, and :permission :type can be any ecto type in addition to :file and :textarea If :choices is provided, it must be a keyword list and the field will be rendered as a &lt;select&gt; element regardless of the actual field type. Setting :permission to :read will make the field non-editable. It is :write by default. If you want to remove a field from being rendered, just remove it from the list. If form_fields/1 is not defined, Kaffy will return all the fields with their default types based on the schema. Example: def form_fields(_schema) do [ title: %{label: &quot;Subject&quot;}, slug: nil, image: %{type: :file}, status: %{choices: [{&quot;Pending&quot;, &quot;pending&quot;}, {&quot;Published&quot;, &quot;published&quot;}]}, body: %{type: :textarea, rows: 3}, views: %{permission: :read} ] end","ref":"Kaffy.ResourceAdmin.html#form_fields/1","title":"Kaffy.ResourceAdmin.form_fields/1","type":"function"},{"doc":"index/1 takes the schema module and should return a keyword list of fields and their options. Supported options are :name and :value. Both options can be a string or an anonymous function. If a fuction is provided, the current entry is passed to it. If index/1 is not defined, Kaffy will return all the fields of the schema and their default values. Example: def index(_schema) do [ id: %{name: &quot;ID&quot;, value: fn post -&gt; post.id + 100 end}, title: nil, # this will render the default name for this field (Title) and its default value (post.title) views: %{name: &quot;Hits&quot;, value: fn post -&gt; post.views + 10 end}, published: %{name: &quot;Published?&quot;, value: fn post -&gt; published?(post) end}, comment_count: %{name: &quot;Comments&quot;, value: fn post -&gt; comment_count(post) end} ] end","ref":"Kaffy.ResourceAdmin.html#index/1","title":"Kaffy.ResourceAdmin.index/1","type":"function"},{"doc":"ordering/1 takes a schema and returns how the entries should be ordered. If ordering/1 is not defined, Kaffy will return [desc: :id]. Example: def ordering(_schema) do [asc: :title] end","ref":"Kaffy.ResourceAdmin.html#ordering/1","title":"Kaffy.ResourceAdmin.ordering/1","type":"function"},{"doc":"This is useful for names that cannot be plural by adding an &quot;s&quot; at the end. Like &quot;Category&quot; =&gt; &quot;Categories&quot; or &quot;Person&quot; =&gt; &quot;People&quot;. If plural_name/1 is not defined, Kaffy will use the singular name and add an &quot;s&quot; to it (e.g. Posts). Example: def plural_name(_schema) do &quot;Categories&quot; end","ref":"Kaffy.ResourceAdmin.html#plural_name/1","title":"Kaffy.ResourceAdmin.plural_name/1","type":"function"},{"doc":"search_fields/1 takes a schema and must return a list of :string fields to search against when typing in the search box. If search_fields/1 is not defined, Kaffy will return all the :string fields of the schema. Example: def search_fields(_schema) do [:title, :slug, :body] end","ref":"Kaffy.ResourceAdmin.html#search_fields/1","title":"Kaffy.ResourceAdmin.search_fields/1","type":"function"},{"doc":"This function should return a string for the singular name of a resource. If singular_name/1 is not defined, Kaffy will use the name of the last part of the schema module (e.g. Post in MyApp.Blog.Post) This is useful for when you have a schema but you want to display its name differently. If you have &quot;Post&quot; and you want to display &quot;Article&quot; for example. Example: def singular_name(_schema) do &quot;Article&quot; end","ref":"Kaffy.ResourceAdmin.html#singular_name/1","title":"Kaffy.ResourceAdmin.singular_name/1","type":"function"},{"doc":"update_changeset/2 takes the record and the changes and should return a changeset for updating an existing record. If update_changeset/2 is not defined, Kaffy will try to call schema.changeset/2 and if that&#39;s not defined, Ecto.Changeset.change/2 will be called. Example: def update_changeset(schema, attrs) do MyApp.Blog.Post.create_changeset(schema, attrs) end","ref":"Kaffy.ResourceAdmin.html#update_changeset/3","title":"Kaffy.ResourceAdmin.update_changeset/3","type":"function"},{"doc":"Kaffy.Routes must be &quot;used&quot; in your phoenix routes: use Kaffy.Routes, scope: &quot;/admin&quot;, pipe_through: [:browser, :authenticate] :scope defaults to &quot;/admin&quot; :pipe_through defaults to kaffy&#39;s [:kaffy_browser]","ref":"Kaffy.Routes.html","title":"Kaffy.Routes","type":"module"},{"doc":"Kaffy Extremely simple yet powerful admin interface for phoenix applications","ref":"readme.html","title":"Kaffy","type":"extras"},{"doc":"Add kaffy as a dependency def deps do [ {:kaffy, &quot;~&gt; 0.2.0&quot;} ] end These are the minimum configurations required # in your router.ex use Kaffy.Routes, scope: &quot;/admin&quot;, pipe_through: [:some_plug, :authenticate] # :scope defaults to &quot;/admin&quot; # :pipe_through defaults to kaffy&#39;s [:kaffy_browser] # in your endpoint.ex plug Plug.Static, at: &quot;/kaffy&quot;, from: :kaffy, gzip: false, only: ~w(css img js scss vendor) # in your config/config.exs config :kaffy, otp_app: :my_app, ecto_repo: Bloggy.Repo, router: BloggyWeb.Router","ref":"readme.html#installation","title":"Kaffy - Installation","type":"extras"},{"doc":"","ref":"readme.html#what-you-get","title":"Kaffy - What You Get","type":"extras"},{"doc":"If you don&#39;t specify a resources option in your configs, Kaffy will try to auto-detect your schemas and your admin modules. Admin modules should be in the same namespace as their respective schemas. For exmaple, if you have a schema MyApp.Products.Product, its admin module should be MyApp.Products.ProductAdmin. If you&#39;d like to explicitly specify your schemas and their admin modules, you can do like the following: # config.exs config :kaffy, admin_title: &quot;Bloggy&quot;, ecto_repo: Bloggy.Repo, router: BloggyWeb.Router, resources: [ blog: [ name: &quot;My Blog&quot;, # a custom name for this context/section. schemas: [ post: [schema: Bloggy.Blog.Post, admin: Bloggy.Blog.PostAdmin], comment: [schema: Bloggy.Blog.Comment], tag: [schema: Bloggy.Blog.Tag] ] ], inventory: [ name: &quot;Inventory&quot;, schemas: [ category: [schema: Bloggy.Products.Category, admin: Bloggy.Products.CategoryAdmin], product: [schema: Bloggy.Products.Product, admin: Bloggy.Products.ProductAdmin] ] ] ] The following admin module is what the screenshot above is showing: # all the functions are optional defmodule Bloggy.Blog.PostAdmin do def index(_schema) do # index/1 should return a keyword list of fields and # their options. # Supported options are :name and :value. # Both options can be a string or an anonymous function. # If a function is provided, the current entry is passed to it. # If this function is not defined, Kaffy will return all the fields of the schema and their default values [ id: %{name: &quot;ID&quot;, value: fn post -&gt; post.id + 100 end}, title: nil, # this will render the default name for this field (Title) and its default value (post.title) views: %{name: &quot;Hits&quot;, value: fn post -&gt; &quot;&lt;strong&gt;\#{post.views}&lt;/strong&gt;&quot; end}, published: %{name: &quot;Published?&quot;, value: fn post -&gt; published?(post) end}, comment_count: %{name: &quot;Comments&quot;, value: fn post -&gt; comment_count(post) end} ] end def form_fields(_schema) do # Supported options are: # :label, :type, :choices, :permission # :type can be any ecto type in addition to :file and :textarea # If :choices is provided, it must be a keyword list and # the field will be rendered as a &lt;select&gt; element regardless of the actual field type. # Setting :permission to :read will make the field non-editable. It is :write by default. # If you want to remove a field from being rendered, just remove it from the list. # If this function is not defined, Kaffy will return all the fields with # their default types based on the schema. [ title: %{label: &quot;Subject&quot;}, slug: nil, image: %{type: :file}, status: %{choices: [{&quot;Pending&quot;, &quot;pending&quot;}, {&quot;Published&quot;, &quot;published&quot;}]}, body: %{type: :textarea, rows: 3}, views: %{permission: :read} ] end def search_fields(_schema) do # Must return a list of :string fields to search against when typing in the search box. # If this function is not defined, Kaffy will return all the :string fields of the schema. [:title, :slug, :body] end def ordering(_schema) do # This returns how the entries should be ordered # if this function is not defined, Kaffy will return [desc: :id] [desc: :id] end def authorized?(_schema, _conn) do # authorized? is passed the schema and the Plug.Conn struct and # should return a boolean value. # returning false will prevent the access of this resource for the current user/request # if this function is not defined, Kaffy will return true. true end def create_changeset(schema, attrs) do # this function should return a changeset for creating a new record # if this function is not defined, Kaffy will try to call: # schema.changeset/2 # and if that&#39;s not defined, Ecto.Changeset.change/2 will be called. Bloggy.Blog.Post.create_changeset(schema, attrs) end def update_changeset(entry, attrs) do # this function should return a changeset for updating an existing record. # if this function is not defined, Kaffy will try to call: # schema.changeset/2 # and if that&#39;s not defined, Ecto.Changeset.change/2 will be called. Bloggy.Blog.Post.update_changeset(entry, attrs) end def singular_name(_schema) do # if this function is not defined, Kaffy will use the name of # the last part of the schema module (e.g. Post) &quot;Post&quot; end def plural_name(_schema) do # if this function is not defined, Kaffy will use the singular # name and add a &quot;s&quot; to it (e.g. Posts) &quot;Posts&quot; end def published?(post) do if post.status == &quot;published&quot;, do: ~s(&lt;span class=&quot;badge badge-success&quot;&gt;&lt;i class=&quot;fas fa-check&quot;&gt;&lt;/i&gt;), else: ~s(&lt;span class=&quot;badge badge-light&quot;&gt;&lt;i class=&quot;fas fa-times&quot;&gt;&lt;/i&gt;&lt;/span&gt;) end defp comment_count(post) do post = Barbican.Repo.preload(post, :comments) length(post.comments) end end","ref":"readme.html#customizations","title":"Kaffy - Customizations","type":"extras"},{"doc":"The form is constructed from the form_fields/1 function if it exists in the admin module. Notice that even though the status field is of type :string, it is rendered as a select element. Also notice that the views field is in &quot;readonly&quot; mode since we gave it the :read permission.","ref":"readme.html#schema-form","title":"Kaffy - Schema Form","type":"extras"},{"doc":"Kaffy was created out of a need to have a minimum, flexible, and customizable admin interface without the need to touch the current codebase. It should work out of the box just by adding some configs in your config.exs file (with the exception of adding a one liner to your router.ex file). A few points that encouraged the creation of Kaffy: Taking contexts into account. Supporting contexts makes the admin interface better organized. Can handle as many schemas as necessary. Whether we have 1 schema or 1000 schemas, the admin interface should adapt well. Have a visually pleasant user interface. This might be subjective. No generators or generated templates. I believe the less files there are the better. This also means it&#39;s easier to upgrade for users when releasing new versions. This might mean some flexibility and customizations will be lost, but it&#39;s a trade-off. Existing schemas/contexts shouldn&#39;t have to be modified. I shouldn&#39;t have to change my code in order to adapt to the package, the package should adapt to my code. Should be easy to use whether with a new project or with existing projects with a lot of schemas. Adding kaffy should be as easy for existing projects as it is for new ones. Highly flexible and customizable. Provide as many configurable options as possible. As few dependencies as possible. Currently kaffy only depends on phoenix and ecto. Simple authorization. I need to limit access for some admins to some schemas. Minimum assumptions. Need to modify a schema&#39;s primary key? Need to hide a certain field? No problem.","ref":"readme.html#why-another-admin-interface","title":"Kaffy - Why another admin interface","type":"extras"}]